.386
.model flat, stdcall
option casemap :none

m2m MACRO M1, M2
push M2
pop  M1
ENDM

FUNC MACRO parameters:VARARG
invoke parameters
EXITM <eax>
ENDM

literal MACRO quoted_text:VARARG
LOCAL local_text
.data
local_text db quoted_text,0
.code
EXITM <local_text>
ENDM

sz MACRO quoted_text:VARARG
EXITM <ADDR literal(quoted_text)>
ENDM

include \MASM32\INCLUDE\windows.inc
include \MASM32\INCLUDE\kernel32.inc
include \MASM32\INCLUDE\user32.inc
include \MASM32\INCLUDE\masm32.inc
include \MASM32\INCLUDE\gdi32.inc
include \MASM32\INCLUDE\oleaut32.inc
includelib \MASM32\LIB\kernel32.lib
includelib \MASM32\LIB\user32.lib
includelib \MASM32\LIB\masm32.lib
includelib \MASM32\LIB\gdi32.lib
includelib \MASM32\LIB\oleaut32.lib

include \masm32\include\dialogs.inc


.data
about db "         R&Q",13,10,13,10
	db " : Winamp, Light Alloy,      api Winamp",13,10
	db " :",13,10,13,10
	db "%track% -   ",13,10
	db "%bitrate% - ,  ,  Winamp",13,10
	db "%samplerate% -  ,  Winamp",13,10
	db "%channels% -   (/),  Winamp",13,10
	db "%length% -  ,  Winamp",13,10
	db "%position% -  ,  Winamp",13,10,13,10
	db "      R&Q 1070  ",0
pluginname db "Winamp2RnQ v2.3",0
sendtrack db " ",0
empty db 0
hWinamp dd 0
player dd 0 ; 1 - WA, 2 - LA
buttid dd 0

opsize equ 258
opver equ 23

Options db opver
createbutton db 0
notsend db 0
pattern db ": %track%",0
db 240 dup (0)

.data?
hInstance dd ?
hDll dd ?
hDlg dd ?
hFile dd ?
hIcon dd ?
buffer db 1024 dup(?)
songbuffer db 512 dup (?)
songbuffer2 db 512 dup (?)
tagbuffer db 512 dup (?)
wbuffer db 512 dup (?)
userpath db 256 dup (?)
bytesread dd ?


include plugin.inc
include callexec.inc

ReplaceXStatus proto
GetSong proto
ReplaceTags proto :DWORD, :DWORD
ButtonProc proto :DWORD
SaveSettings proto
Preferences proto
DlgProc proto:DWORD, :DWORD, :DWORD, :DWORD

.code

LibMain proc hInstDLL:DWORD, reason:DWORD, unused:DWORD
.if reason == DLL_PROCESS_ATTACH
	m2m hDll,hInstDLL
	xor eax,eax
	invoke GetModuleHandle,eax
	mov hInstance,eax
	invoke LoadIcon,hInstDLL,101
	mov hIcon,eax
	xor eax,eax
	inc eax
	ret
.endif
ret
LibMain Endp

pluginFun proc data:DWORD
	mov eax,data
	xor ecx,ecx
	mov cl, [eax+4]
	.if ecx == PM_EVENT
		mov cl, [eax+5]
		.if ecx == PE_INITIALIZE
			mov ecx, [eax+6]
			mov callback, ecx
			
			mov ecx,[eax+14]
			add eax,ecx
			add eax,18
			mov ecx,[eax]
			push ecx
			add eax,4
			invoke MemCopy,eax,addr userpath,ecx
			pop eax
			add eax, offset userpath
			mov byte ptr [eax],0
			invoke lstrcat, addr userpath, sz("wa2rnq.dat")
			xor eax,eax
			invoke CreateFile, addr userpath, GENERIC_READ,FILE_SHARE_READ,eax,OPEN_EXISTING,eax,eax
			.if eax != INVALID_HANDLE_VALUE
				mov hFile, eax
				invoke ReadFile,hFile,addr Options,1,addr bytesread,0
				.if Options == opver
					invoke ReadFile,hFile,addr createbutton,opsize,addr bytesread,0
				.else
					mov Options, opver
				.endif
				invoke CloseHandle, hFile
			.endif

			.if createbutton != 0
				invoke RQ_CreateChatButton,addr ButtonProc,hIcon,addr sendtrack
				mov buttid, eax
			.endif
			
			mov byte ptr buffer, PM_DATA
			invoke lstrlen, addr pluginname
			mov dword ptr buffer+1,eax
			push eax
			invoke lstrcpy, offset buffer+5, addr pluginname
			add eax,dword ptr buffer+1
			mov dword ptr [eax],4
			pop eax
			add eax,9
			invoke str2comm, addr buffer,eax
			ret
		.elseif ecx == PE_FINALIZE
			.if buttid != 0
				invoke RQ_DeleteChatButton,buttid
			.endif
		.elseif ecx == PE_PREFERENCES
			invoke Preferences
		.elseif ecx == PE_XSTATUSMSG_SENT
			push eax
			invoke GetSong
			invoke MultiByteToWideChar,CP_ACP,0,addr songbuffer,-1,addr songbuffer2,256
			invoke WideCharToMultiByte,65001,0,addr songbuffer2,-1,addr songbuffer,512,0,0
			pop eax
			invoke ReplaceXStatus
			invoke str2comm, addr buffer,eax
			ret
		.endif
	.endif
	xor eax,eax
ret
pluginFun endp

GetSong proc
	invoke FindWindow,sz("LightAlloyFront"),0
	mov hWinamp,eax
	.if eax == 0
		invoke FindWindow,sz("Winamp v1.x"),0
		.if eax != 0
			mov player, 1
		.endif
	.else
		mov player, 2
	.endif
	mov hWinamp,eax
	.if eax == 0
		mov player,eax
		mov byte ptr songbuffer,al
	.else
		.if player == 1
			invoke GetWindowText,hWinamp,addr songbuffer2,255
			invoke lstrlen, addr songbuffer2
			invoke SBMBinSearch,0,addr songbuffer2,eax,sz(" - Winamp"),9
			cmp eax, -1
			je error
			add eax, offset songbuffer2
			mov byte ptr [eax],0
			invoke lstrlen, addr songbuffer2
			invoke SBMBinSearch,0,addr songbuffer2,eax,sz(". "),2
			cmp eax,-1
			je error
			add eax,2
			add eax, offset songbuffer2
			invoke lstrcpy, addr songbuffer, eax
		.elseif player == 2
			invoke GetWindowText,hWinamp,addr songbuffer,255
			invoke lstrlen, addr songbuffer
			invoke SBMBinSearch,0,addr songbuffer,eax,sz(" - Light Alloy"),14
			cmp eax, -1
			je error
			add eax, offset songbuffer
			mov byte ptr [eax],0
		.endif
	.endif
ret
error:
mov byte ptr songbuffer,0
ret
GetSong endp

ReplaceXStatus proc uses esi edi
	add eax,11
	mov esi,eax
	mov byte ptr buffer,PM_DATA
	mov edi,[esi]
	add edi,4
	invoke MemCopy,esi,addr buffer+1,edi
	add esi,edi
	mov eax,[esi]
	add esi,4
	push eax
	invoke MemCopy,esi,addr wbuffer,eax
	pop eax
	add eax,offset wbuffer
	mov byte ptr [eax],0
	add edi,5
	mov esi,offset buffer
	add esi,edi
	invoke ReplaceTags,addr wbuffer,esi	
	invoke lstrlen,esi
	mov [esi-4],eax
	add eax,edi
	ret
ReplaceXStatus endp

ReplaceTags proc src:DWORD, dst:DWORD
	invoke szRep,src,dst,sz("%track%"), addr songbuffer

	invoke lstrcpy,src,dst	
	invoke SendMessage,hWinamp,WM_USER,1,126
	invoke dw2a,eax,addr tagbuffer
	invoke szRep,src,dst,sz("%bitrate%"), addr tagbuffer
	
	invoke lstrcpy,src,dst
	invoke SendMessage,hWinamp,WM_USER,0,126
	invoke dw2a,eax,addr tagbuffer
	invoke szRep,src,dst,sz("%samplerate%"), addr tagbuffer

	invoke lstrcpy,src,dst
	invoke SendMessage,hWinamp,WM_USER,2,126
	.if eax == 1
		invoke szRep,src,dst,sz("%channels%"), sz("mono")
	.elseif eax == 2
		invoke szRep,src,dst,sz("%channels%"), sz("stereo")	
	.else 
		invoke dw2a,eax,addr tagbuffer
		invoke lstrcat,addr tagbuffer,sz("ch")
		invoke szRep,src,dst,sz("%channels%"), addr tagbuffer
	.endif

	invoke lstrcpy,src,dst
	invoke SendMessage,hWinamp,WM_USER,1,105
	xor edx,edx
	mov ecx,60
	idiv ecx
	push edx
	invoke dw2a,eax,addr tagbuffer
	invoke lstrlen,addr tagbuffer
	add eax, offset tagbuffer
	mov byte ptr [eax],':'
	inc eax
	pop edx
	.if edx < 10
		mov byte ptr [eax], '0'
		inc eax
	.endif	
	invoke dw2a,edx,eax
	invoke szRep,src,dst,sz("%length%"), addr tagbuffer

	invoke lstrcpy,src,dst
	invoke SendMessage,hWinamp,WM_USER,0,105
	.if eax == -1
		inc eax
	.endif
	xor edx,edx
	mov ecx,1000
	idiv ecx
	xor edx,edx
	mov ecx,60	
	idiv ecx
	push edx
	invoke dw2a,eax,addr tagbuffer
	invoke lstrlen,addr tagbuffer
	add eax, offset tagbuffer
	mov byte ptr [eax],':'
	inc eax	
	pop edx
	.if edx < 10
		mov byte ptr [eax], '0'
		inc eax
	.endif	
	invoke dw2a,edx,eax
	invoke szRep,src,dst,sz("%position%"), addr tagbuffer
	
ret
ReplaceTags endp

Preferences proc
	Dialog "", "MS Sans Serif",8, WS_OVERLAPPED or WS_SYSMENU or DS_CENTER, 8 ,0,0,250,130,1024
	DlgCheck "     '",WS_TABSTOP,5,2,150,10,201
	DlgStatic "  :",SS_LEFT,5,14,140,10,-1
	DlgEdit WS_TABSTOP or WS_BORDER or ES_WANTRETURN or ES_MULTILINE or ES_AUTOHSCROLL or ES_AUTOVSCROLL or WS_HSCROLL or WS_VSCROLL,5,26,235,52,202
	DlgRadio " ", WS_TABSTOP,5,80,75,10,203
	DlgRadio "   ", WS_TABSTOP,85,80,140,10,204
	
	DlgButton " / ",WS_TABSTOP,5, 92, 100, 13,209
	DlgButton "",WS_TABSTOP,125, 92, 60, 13,210
	DlgButton "OK",WS_TABSTOP or BS_DEFPUSHBUTTON,190, 92, 50, 13,211    

CallModalDialog hInstance,0,DlgProc,NULL
ret
Preferences endp

DlgProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
.if uMsg == WM_INITDIALOG

	push hWnd
	pop hDlg
	.if createbutton != 0
 		invoke CheckDlgButton,hDlg,201,BST_CHECKED
 	.else
		invoke GetDlgItem,hDlg,202
 		invoke EnableWindow,eax,0
		invoke GetDlgItem,hDlg,203
 		invoke EnableWindow,eax,0
		invoke GetDlgItem,hDlg,204
 		invoke EnableWindow,eax,0
 	.endif
 	
 	.if notsend == 0
 		invoke CheckRadioButton,hDlg,203,204,203
 	.else
 		invoke CheckRadioButton,hDlg,203,204,204
 	.endif
 	
 	invoke SetDlgItemText,hDlg,202, addr pattern
 
.elseif uMsg == WM_CLOSE
	invoke EndDialog,hWnd,0

.elseif uMsg == WM_COMMAND
	mov eax, wParam
	.if eax == 209
		invoke MessageBox,0,addr about, addr pluginname, MB_ICONASTERISK
	.elseif eax == 210
		invoke EndDialog,hWnd,0
	.elseif eax == 211
		invoke IsDlgButtonChecked,hWnd,201
		.if eax == BST_CHECKED
			.if createbutton == 0
				invoke RQ_CreateChatButton,addr ButtonProc,hIcon,addr sendtrack
				mov buttid, eax
				mov createbutton,1
			.endif
		.else
			.if createbutton == 1
				invoke RQ_DeleteChatButton,buttid
				mov createbutton,0
			.endif
		.endif
		
		invoke IsDlgButtonChecked,hWnd,203
		.if eax == BST_CHECKED
			mov notsend, 0
		.else
			mov notsend, 1
		.endif
		
		invoke GetDlgItemText,hDlg,202,addr pattern, 255
		
		call SaveSettings
		invoke EndDialog,hWnd,0
	.elseif eax == 201
		invoke IsDlgButtonChecked,hWnd,201
		.if eax == BST_CHECKED
			invoke GetDlgItem,hDlg,202
 			invoke EnableWindow,eax,1
			invoke GetDlgItem,hDlg,203
 			invoke EnableWindow,eax,1
			invoke GetDlgItem,hDlg,204
 			invoke EnableWindow,eax,1
 		.else
			invoke GetDlgItem,hDlg,202
 			invoke EnableWindow,eax,0
			invoke GetDlgItem,hDlg,203
 			invoke EnableWindow,eax,0
			invoke GetDlgItem,hDlg,204
 			invoke EnableWindow,eax,0
		.endif
	.endif
.endif
xor eax,eax
ret
DlgProc endp

ButtonProc proc buttstate:DWORD
LOCAL buff[512]: BYTE
	invoke GetSong
	invoke lstrcpy,addr wbuffer,addr pattern
	invoke ReplaceTags,addr wbuffer, addr buff
	.if notsend == 0
		invoke RQ_GetChatUIN
		mov ecx,eax
		invoke RQ_SendMsg,ecx,0,addr buff
	.else
		invoke RQ_AddToInput, addr buff
	.endif
ret
ButtonProc endp

SaveSettings proc
	xor eax,eax
	invoke CreateFile, addr userpath, GENERIC_WRITE,FILE_SHARE_READ,eax,CREATE_ALWAYS,eax,eax
	.if eax != INVALID_HANDLE_VALUE
		mov hFile, eax
		invoke WriteFile,hFile,addr Options,opsize+1,addr bytesread,0
		invoke CloseHandle, hFile
	.endif
ret
SaveSettings endp

End LibMain